/** @file depend.h

	Skelton for retropc emulator
	SDL edition

	@author Sasaji
	@date   2012.03.01

	@brief [ dependency definition ]
*/

#ifndef _DEPEND_H_
#define _DEPEND_H_

#if defined(_DEBUG) && defined(_WIN32) && !defined(__MINGW32__)
#define _CRTDBG_MAP_ALLOC
#include <stdlib.h>
#include <crtdbg.h>
#endif

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>

#ifdef _WIN32
/* windows */
#include <tchar.h>

#ifdef __MINGW32__
#include <getopt.h>
#endif

#else
/* linux, macosx */
#include <unistd.h>
#include "extra/tchar.h"

#define __stdcall

#endif

#ifndef _MAX_PATH
#define _MAX_PATH	(260)
#endif

#ifdef _UNICODE
#define MBSTOWCS(dst, src, len) mbstowcs(dst, src, len)
#define WCSTOMBS(dst, src, len) wcstombs(dst, src, len)
#else
#define MBSTOWCS(dst, src, len) strncpy(dst, src, len)
#define WCSTOMBS(dst, src, len) strncpy(dst, src, len)
#endif

#endif	/* _DEPEND_H_ */

