/** @file ag_config_dlg.h

	Skelton for retropc emulator
	SDL + Agar edition

	@author Sasaji
	@date   2012.04.08

	@brief [ ag_config_dlg ]
*/

#ifndef _AG_CONFIG_DLG_H_
#define _AG_CONFIG_DLG_H_

#include "ag_dlg.h"

enum ConfigBoxParamId {
	FddType,
	WavReverse,
	WavHalf,
	WavCorrect,
	WavCorrectType,
	WavSampleRate,
	WavSampleBits,
	IOPort
};

/**
	@brief config dialog
*/
class AG_CONFIG_DLG : public AG_DLG {
	friend class AG_GUI_BASE;

private:
	typedef struct ConfigDlgParam_st {
		int  fdd_type;

		int  wav_reverse;
		int  wav_half;
		int  wav_correct;
		int  wav_correct_type;

		int  wav_sample_rate;
		int  wav_sample_bits;

		int  io_port;

		int  disptmg_skew;
		int  curdisp_skew;
	} ConfigDlgParam;

	ConfigDlgParam param;
	ConfigDlgParam paramtmp;

	char *radFddType[4];
	char radFddTypeBase[4][32];

	AG_Checkbox *chkIOPort[8];
	char chkIOPortBase[8][32];

	void change_fdd_type(int);
	void change_io_port(int, int);

	static void OnOk(AG_Event *);
	static void OnClose(AG_Event *);
	static void OnChangeCorrect(AG_Event *);
	static void OnChangeSampleRate(AG_Event *);
	static void OnChangeSampleBits(AG_Event *);
	static void OnChangeFddType(AG_Event *);
	static void OnChangeIOPort(AG_Event *);
	static void OnChangeDisptmgSkew(AG_Event *);
	static void OnChangeCurdispSkew(AG_Event *);

public:
	AG_CONFIG_DLG(EMU *, AG_GUI_BASE *);
	~AG_CONFIG_DLG();

	void Create();
	void Update();

	int GetParam(ConfigBoxParamId);

};

#endif /* _AG_CONFIG_DLG_H_ */
